from vpython import *
import numpy as np
import time
import winsound

Tick_Frequency = 1500
Tick_Duration = 400
Tock_Frequency = 1000
Tock_Duration = 400

clockR = 1
clockThickness = clockR/10
majorTickLength = clockR/7
majorTickThickness = 2*np.pi*clockR/400
majorTickWidth = clockThickness*1.2

minorTickLength = clockR/12
minorTickThickness = 2*np.pi*clockR/600
minorTickWidth = clockThickness*1.2

minuteHandL = clockR-majorTickLength
minuteHandThickness = minuteHandL/25
minuteHandOffset = clockThickness/2 + minuteHandThickness

secondHandL = clockR/2+clockR/4
secondHandThickness = minuteHandL/50
secondHandOffset = clockThickness*1.5 + minuteHandThickness

HourHandL = .75 * minuteHandL
HourHandThickness = minuteHandThickness*1.25
HourHandOffset = clockThickness + HourHandThickness

hubRadius = clockThickness/2
HourHandAngle = np.pi/2
minuteHandAngle = np.pi/2
minInc=.0001
hourInc = minInc/12
secondHandAngle = np.pi/2
secondInc = minInc*60

Minute_Hand_Radius=clockThickness/4
Hour_Hand_Radius=clockThickness/4
Second_Hand_Radius=clockThickness/12
Hand_Gap=Second_Hand_Radius

for theta in np.linspace(0,2*np.pi,13):
    majorTick = box(axis = vector(clockR*np.cos(theta),clockR*np.sin(theta),0),color = color.black, length = majorTickLength, width = majorTickWidth,height = majorTickThickness, pos = vector((clockR-majorTickLength/2)*np.cos(theta),(clockR-majorTickLength/2)*np.sin(theta),0))
for theta in np.linspace(0,2*np.pi,61):
    minorTick = box(axis = vector(clockR*np.cos(theta),clockR*np.sin(theta),0),color = color.black, length = minorTickLength, width = minorTickWidth, height = minorTickThickness, pos = vector((clockR-minorTickLength/2)*np.cos(theta),(clockR-minorTickLength/2)*np.sin(theta),0))

clockFace = cylinder(length = clockThickness, radius = clockR,  axis = vector(0,0,1),color = color.white, pos = vector(0,0,-clockThickness/2))
ClockEdge = ring(pos=vector(0,0,0),axis = vector(0,0,1), radius = clockR+clockR/10, thickness=clockThickness,color = color.white)
clockFace = cylinder(length = clockThickness, radius = clockR + clockR/10,  axis = vector(0,0,1),color = color.white, pos = vector(0,0,-clockThickness))
minuteHand = arrow(axis=vector(0,1,0),color = color.gray(0.4), shaftwidth = minuteHandThickness, length = minuteHandL, pos=vector(0,0,minuteHandOffset))
HourHand = arrow(axis=vector(0,1,0),color = color.gray(0.4), shaftwidth = HourHandThickness, length = HourHandL, pos=vector(0,0,HourHandOffset))
secondHand = arrow(axis=vector(0,1,0),color = color.gray(0.4), shaftwidth = secondHandThickness, length = secondHandL, pos=vector(0,0,secondHandOffset))

hub = cylinder(axis = vector(0,0,1),color = color.gray(0.4), radius=hubRadius, length = 2*clockThickness)
textHeight = clockR/4
Labels = text(text="India Local time",align = 'center', height = textHeight, pos = vector(0,1.3*clockR,clockThickness/2),depth=clockThickness)
Angle = np.pi/2
AngleInc =-2*np.pi/4
Angle = Angle+AngleInc
textH = clockR/8
for i in range(3,13,3):
    clockNumber = text(align='center',text=str(i), pos = vector(clockR*0.75*np.cos(Angle),(clockR*0.75*np.sin(Angle))-textH/2,0), height = textH, depth = clockThickness,color = color.black)
    Angle=Angle+AngleInc

Tick=False
Tock=True

while True:
    rate(5000)
    hour = time.localtime(time.time())[3]
    if hour>12:
        hour = hour-12
    minute = time.localtime(time.time())[4]
    second = time.localtime(time.time())[5]
    HourHandAngle = -((hour+(minute/60))/12)*2*np.pi+np.pi/2
    minuteHandAngle =-((minute+(second/60))/60)*2*np.pi+np.pi/2
    secondHandAngle = -(second/60)*2*np.pi+np.pi/2
    print(second) 
    HourHand.axis=vector(HourHandL*np.cos(HourHandAngle),HourHandL*np.sin(HourHandAngle),0)
    minuteHand.axis=vector(minuteHandL*np.cos(minuteHandAngle),minuteHandL*np.sin(minuteHandAngle),0)
    secondHand.axis=vector(secondHandL*np.cos(secondHandAngle),secondHandL*np.sin(secondHandAngle),0)

    if Tock==True and second % 2 == 1 :
        winsound.Beep(Tick_Frequency,Tick_Duration)
        Tick=True
        Tock=False
    if Tick==True and second % 2 == 0 :
        winsound.Beep(Tock_Frequency,Tock_Duration)
        Tock=True
        Tick=False